﻿

'
'
'/**
'--------------------------------------------------
' Version .....: 05/11/2008 10:35:53   
'               [dd/mm/aaaa] 
' Original en .: BuscaColor
'--------------------------------------------------
'
'
' -------------------------------------------------
' Clase ....: BuscaColor
' Lenguaje .: (.NET Framework 3.5) - Visual Basic .NET (Version 9.0) - 2008
' Autor ....: Mi Casita - AGUILA - Joaquin
' Emilio ...: mailto:joaquin@medina.name
'
' DESCRIPCION.:
'     Formulario que obtiene el color de un pixel de la pantalla
'
' OBSERVACIONES.:
'     Sin la referecia [Microsoft.VisualBasic] Sin Usar ControlChars
'
' BIBLIOGRAFIA.:
'    ### falta la Bibliografía ###
'
' MODIFICACIONES [dd/mm/aaaa] 
' - 05/11/2008 10:35:53 - Creación 
' -------------------------------------------------
'
'*/
'



''' <summary>
'''    Herramienta que obtiene el color de un pixel de la pantalla
''' </summary>
Public Class BuscaColor


    '--------------------------------------------------------------
    ' Evento Load del Form
    Private Sub BuscaColor_Load( _
             ByVal sender As System.Object, ByVal e As System.EventArgs) _
             Handles MyBase.Load

        Me.ToolStripStatusLabel1.Text = _
                  Servicios.Variado.TextosFormularios.TextoParaBarraEstado
        Me.Text = Servicios.Variado.TextosFormularios.TextoParaBarraTitulo

    End Sub


    '--------------------------------------------------------------
    ' Evento que dispara el control [UcBuscaColor] cuando captura un color
    ' lo que hacemos es recogerlo y mostrar los resultados
    Private Sub UcBuscaColor1_ColorCapturado( _
            ByVal sender As Object, ByVal e As System.EventArgs) _
            Handles UcBuscaColor1.ZColorCapturado

        Me.PictureBoxColorSeleccionado.BackColor = Me.UcBuscaColor1.ZColor

        '--------------------------------------------------------------
        Dim provider As System.Globalization.CultureInfo
        provider = System.Globalization.CultureInfo.CurrentCulture
        Dim cadenaFormato As String = String.Empty

        Dim auxColor As Drawing.Color = Me.UcBuscaColor1.ZColor

        '--------------------------------------------------------------
        cadenaFormato = _
           "[A={0:g3}, R={1:g3}, G={2:g3}, B={3:g3}]"

        Me.TextBoxRGBDec.Text = String.Format( _
                                provider, _
                                cadenaFormato, _
                                   auxColor.A, auxColor.R, _
                                   auxColor.G, auxColor.B)

        '--------------------------------------------------------------
        cadenaFormato = _
           "[A={0:X2},  R={1:X2},  G={2:X2},  B={3:X2}]"

        Me.TextBoxRGBHTML.Text = String.Format( _
                                provider, _
                                cadenaFormato, _
                                   auxColor.A, auxColor.R, _
                                   auxColor.G, auxColor.B)

    End Sub



    '--------------------------------------------------------------
    'BOTONES
    '--------------------------------------------------------------


    '--------------------------------------------------------------
    ' terminar la ejecucion del programa
    Private Sub ButtonAceptar_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles ButtonAceptar.Click
        Call AccionDeMenu_Cerrar()
    End Sub

    '--------------------------------------------------------------
    'Copiar el valor de color hexadecimal para HTML al portapapeles
    Private Sub ButtonCopiar_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles ButtonCopiar.Click
        Call AccionDeMenu_Copiar()
    End Sub

    '--------------------------------------------------------------
    ' muestra un informe con los resultados de la captura
    Private Sub ButtonVerResultado_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles ButtonVerResultado.Click
        Me.UcBuscaColor1.ZShowDialogResultados()
    End Sub

    '--------------------------------------------------------------
    ' Inicialia los controles a su valor incial
    Private Sub ButtonBorrar_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles ButtonBorrar.Click
        Call AccionDeMenu_Inicializar()
    End Sub

    '--------------------------------------------------------------
    ' muestra una pantalla de ayuda
    Private Sub ButtonAyuda_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles ButtonAyuda.Click
        Call AccionDeMenu_Ayuda()
    End Sub


    '--------------------------------------------------------------
    'MENUS
    '--------------------------------------------------------------



    '--------------------------------------------------------------
    ' Inicialia los controles a su valor incial
    Private Sub NuevoToolStripMenuItem_Click( _
               ByVal sender As System.Object, ByVal e As System.EventArgs) _
               Handles NuevoToolStripMenuItem.Click
        Call AccionDeMenu_Inicializar()
    End Sub

    '--------------------------------------------------------------
    'Termina la ejecucion del programa
    Private Sub CerrarToolStripMenuItem_Click( _
              ByVal sender As System.Object, ByVal e As System.EventArgs) _
              Handles CerrarToolStripMenuItem.Click
        Call AccionDeMenu_Cerrar()
    End Sub

    '--------------------------------------------------------------
    ' muestra una pantalla de ayuda
    Private Sub AyudaToolStripMenuItem1_Click( _
              ByVal sender As System.Object, ByVal e As System.EventArgs) _
              Handles AyudaToolStripMenuItem1.Click
        Call AccionDeMenu_Ayuda()
    End Sub

    '--------------------------------------------------------------
    ' muestra una pantalla de ayuda Acerca De
    Private Sub AcercaDeToolStripMenuItem_Click( _
               ByVal sender As System.Object, ByVal e As System.EventArgs) _
               Handles AcercaDeToolStripMenuItem.Click
        Call AccionDeMenu_AcercaDe()
    End Sub

    '--------------------------------------------------------------
    'Copiar el valor de color hexadecimal para HTML al portapapeles
    Private Sub CopiarToolStripMenuItem_Click( _
               ByVal sender As System.Object, ByVal e As System.EventArgs) _
               Handles CopiarToolStripMenuItem.Click
        Call AccionDeMenu_Copiar()
    End Sub

    '--------------------------------------------------------------
    ' muestra un informe con los resultados de la captura
    Private Sub VerInformeToolStripMenuItem_Click( _
               ByVal sender As System.Object, ByVal e As System.EventArgs) _
               Handles VerInformeToolStripMenuItem.Click
        Call AccionDeMenu_Informe()
    End Sub



    '--------------------------------------------------------------
    'ACCIONES DE MENU
    '--------------------------------------------------------------

    '--------------------------------------------------------------
    'Termina la ejecucion del programa
    Private Sub AccionDeMenu_Cerrar()
        Me.Close()
    End Sub
    '--------------------------------------------------------------
    'Copiar el valor de color hexadecimal para HTML al portapapeles
    Private Sub AccionDeMenu_Copiar()
        Me.TextBoxRGBHTML.SelectAll()
        Me.TextBoxRGBHTML.Copy()
    End Sub
    '--------------------------------------------------------------
    ' Inicialia los controles a su valor incial
    Private Sub AccionDeMenu_Inicializar()
        Me.UcBuscaColor1.ZClear()
        Me.PictureBoxColorSeleccionado.BackColor = Me.BackColor

        Me.TextBoxRGBDec.Clear()
        Me.TextBoxRGBHTML.Clear()
    End Sub
    '--------------------------------------------------------------
    ' muestra una pantalla de ayuda
    Private Sub AccionDeMenu_Ayuda()
        DllColor.UCBuscaColor.ZShowDialogAyuda()
    End Sub
    '--------------------------------------------------------------
    ' muestra una pantalla de ayuda Acerca De
    Private Shared Sub AccionDeMenu_AcercaDe()
        Dim formAyuda As New BuscaColorAcercaDE
        formAyuda.ShowDialog()
        formAyuda.Close()
        formAyuda.Dispose()
        formAyuda = Nothing
    End Sub
    '--------------------------------------------------------------
    ' muestra un informe con los resultados de la captura
    Private Sub AccionDeMenu_Informe()
        Me.UcBuscaColor1.ZShowDialogResultados()
    End Sub


   
End Class