

'---------------------------------------------------------------------------
' Version ..: 28/04/2008
' Original en Dll Servicios
'---------------------------------------------------------------------------



'
'/**
'---------------------------------------------------------------------------
' Fichero ..: TextosFormularios.vb.vb
' Lenguaje .: Visual Basic NET
' Autor ....: Joaquin Medina Serrano
' Emilio ...: jms32@eresmas.net
' Fecha ....: 28/11/2006
'
' DESCRIPCION.:
'    Genera los textos para el titulo y la Barra de Estado de un formulario
'    
' OBSERVACIONES.:
'     Diseada para trabajar en Visual Basic 
'     sin la referecia [Microsoft.VisualBasic] Sin Usar ControlChars
'
'
' MODIFICACIONES
'-  07/04/2007 Creacion de la clase
' - 27/04/2008 - FxCop Reglas
'
' -------------------------------------------------
'*/
'




Option Explicit On
Option Strict On
Option Compare Binary



Namespace Servicios.Variado


    ''' <summary>
    ''' Genera los textos para el titulo y la Barra de Estado de un formulario
    ''' </summary>
    Friend NotInheritable Class TextosFormularios

        '-------------------------------------------
        ' el ao en el que se realiza el programa
        Private Const AO_PARTIDA As Integer = 2008


        ''' <summary>
        '''  Constructor privado (Regla FxCop)
        ''' </summary>
        Private Sub New()
            '--------------------------------------------------------------------------
            ' Regla FxCop
            '--------------------------------------------------------------------------
            '    Resolution   : "'TextosFormularios' is an internal class that is 
            '                   apparently never instantiated. If so, remove the code 
            '                   from the assembly. If this class is intended to contain 
            '                   only static methods, consider adding a private constructor 
            '                   to prevent the compiler from generating a default constructor."
            '    Help         : http://msdn2.microsoft.com/ms182265(VS.90).aspx  (String)
            '    Category     : Microsoft.Performance  (String)
            '    CheckId      : CA1812  (String)
            '    RuleFile     : Performance Rules  (String)
            '    Info         : "An internal class was detected that is apparently never 
            '                   instantiated. This rule does not attempt to detect 
            '                   late-bound creation and will generate false positives 
            '                   if instances of a type are only created in this way 
            '                   (for example, by means of Activator.CreateInstance 
            '                   or by passing the type as an argument to a TypeConverter 
            '                   constructor)."
            '    Created      : 27/04/2008 7:34:20  (DateTime)
            '--------------------------------------------------------------------------
        End Sub



        '---------------------------------------------------
        ''' <summary>
        '''  Obtiene un texto para ser mostrado en la
        '''  barra de estado de un formulario
        ''' </summary>
        ''' <returns>
        ''' Devuelve la cadena  " Joaquin 'jms32' Medina Serrano 2007-2009
        ''' </returns>
        ''' <remarks>
        ''' <para>Obtiene la informacion de [AssemblyInfo]</para>
        ''' <para>
        '''     En la barra de estado [StatusStrip1.Items] hay que aadir
        '''     un [StatusLabel] que automaticamente tomara el nombre
        '''     de [ToolStripStatusLabel1]
        ''' </para>
        ''' <para>
        '''    En la propiedad [ToolStripStatusLabel1.Text] es donde hay 
        '''    que cargar el texto resultado de esta funcion
        ''' </para>
        ''' </remarks>
        ''' <example>
        '''  Me.ToolStripStatusLabel1.Text =TextoParaBarraEstado
        ''' </example>
        Public Shared Function TextoParaBarraEstado() As String

            'Dim fvi As Microsoft.VisualBasic.ApplicationServices.AssemblyInfo = _
            '          My.Application.Info
            ' Dim fvi As System.Diagnostics.FileVersionInfo = Nothing
            Dim sb As System.Text.StringBuilder = Nothing
            Try
                'fvi = System.Diagnostics.FileVersionInfo.GetVersionInfo( _
                '      System.Reflection.Assembly.GetExecutingAssembly.Location)


                'elCopyright (autor y fecha)  a la barra de estado
                sb = New System.Text.StringBuilder()
                sb.AppendFormat( _
                  System.Globalization.CultureInfo.CurrentCulture, _
                  "  Joaquin 'jms32' Medina Serrano , {0}", _
                   AO_PARTIDA.ToString(System.Globalization.CultureInfo.CurrentCulture))

                ' aadir el segundo ao (p.e:2007-2008) si es posterior al 2007

                ' aadir el ao si es posterior 2006-2008
                If DateTime.Now.Year > AO_PARTIDA Then
                    sb.AppendFormat( _
                       System.Globalization.CultureInfo.CurrentCulture, _
                       "-{0} ", DateTime.Now.Year)
                End If

                Return sb.ToString

            Catch ex As Exception
                Throw

            Finally
                ' fvi = Nothing
                sb = Nothing
            End Try
        End Function



        '---------------------------------------
        ' cargar los valores de la barra de titulo 
        ' COPIAR ESTA FUNCION EN E FORM
        '   Me.Text = GetTextoParaBarraTitulo


        '---------------------------------------------------
        ''' <summary>
        '''  Obtiene un texto para ser mostrado en la
        '''  barra de titulo de un formulario
        ''' </summary>
        ''' <returns>
        ''' Devuelve una cadena con el nombre de la apliccion
        ''' </returns>
        ''' <remarks>Obtiene la informacion de [AssemblyInfo]</remarks>
        ''' <example>  Me.Text = TextoParaBarraTitulo</example>
        Public Shared Function TextoParaBarraTitulo() As String

            Dim fvi As System.Diagnostics.FileVersionInfo = Nothing
            Try
                fvi = System.Diagnostics.FileVersionInfo.GetVersionInfo( _
                        System.Reflection.Assembly.GetExecutingAssembly.Location)

                ' cargar el titulo del Formulario
                Return String.Format( _
                          System.Globalization.CultureInfo.CurrentCulture, _
                          fvi.FileDescription)

            Catch ex As Exception
                Throw
            Finally
                fvi = Nothing
            End Try

        End Function

    End Class
End Namespace
