﻿

'
'
'/**
'--------------------------------------------------
' Version .....: 05/11/2008 10:35:53   
'               [dd/mm/aaaa] 
' Original en .: DllColor
'--------------------------------------------------
'
'
' -------------------------------------------------
' Clase ....: UCBuscaColor
' Lenguaje .: (.NET Framework 3.5) - Visual Basic .NET (Version 9.0) - 2008
' Autor ....: Mi Casita - AGUILA - Joaquin
' Emilio ...: mailto:joaquin@medina.name
'
' DESCRIPCION.:
'     Control de usuario que obtiene el color de un pixel de la pantalla
'
' OBSERVACIONES.:
'     Sin la referecia [Microsoft.VisualBasic] Sin Usar ControlChars
'
' BIBLIOGRAFIA.:
'    ### falta la Bibliografía ###
'
' MODIFICACIONES [dd/mm/aaaa] 
' - 05/11/2008 10:35:53 - Creación 
' -------------------------------------------------
'
'*/
'



Imports System.Drawing ' para el bitmap y Bitmap
Imports System.Windows.Forms ' para screen y Cursors

''' <summary>
'''    Control de usuario que obtiene el color de un pixel de la pantalla
''' </summary>
''' <remarks>
''' </remarks>
<Serializable()> _
Public Class UCBuscaColor
    Implements IDisposable


#Region "Evento Enter del control"
    '-----------------------------------------------------------------------
    Private Sub GroupBoxColor_Enter( _
            ByVal sender As System.Object, _
            ByVal e As System.EventArgs) _
            Handles GroupBoxColor.Enter

        ' textos de ayuda emergente
        Using sw As New System.IO.StringWriter( _
         System.Globalization.CultureInfo.CurrentCulture)

            sw.WriteLine("Pulsa el botón izquierdo del ratón y arrastra la Cruz [+] ")
            sw.WriteLine("por el escritorio hasta localizar el color que quieres copiar")
            sw.Flush()

            Me.ToolTip1.SetToolTip( _
                 Me.ButtonArrastraRaton, _
                 sw.ToString)
        End Using

        Me.ToolTip1.IsBalloon = True
    End Sub

#End Region

#Region "Interface publica"

    ''' <summary>
    '''    Valor del color
    ''' </summary>
    Public ReadOnly Property ZColor() As Drawing.Color
        Get
            Return Me._colorCalculado
        End Get
    End Property


    ''' <summary>
    '''  Devuelve Las coordenads del punto de captura del color
    ''' </summary>
    Public ReadOnly Property ZCoordenadasCaptura() As Point
        Get
            Return Me._posicionCursor
        End Get
    End Property


    ''' <summary>
    '''  Devuelve el valor Html del color.
    ''' </summary>
    Public ReadOnly Property ZColorHtml() As String
        Get

            '--------------------------------------------------------------
            Dim provider As System.Globalization.CultureInfo
            provider = System.Globalization.CultureInfo.CurrentCulture
            Dim cadenaFormato As String = String.Empty
            Dim auxResultado As String = String.Empty
            '--------------------------------------------------------------
            cadenaFormato = _
            "[ARGB Hex] [A={0:X2},  R={1:X2},  G={2:X2},  B={3:X2}]"

            auxResultado = String.Format( _
                             provider, _
                             cadenaFormato, _
                                 _colorCalculado.A, _colorCalculado.R, _
                                 _colorCalculado.G, _colorCalculado.B)

            Return auxResultado
        End Get
    End Property


    ''' <summary>
    '''  Muestra un formulario con los resultados obtenidos
    ''' </summary>
    <System.ComponentModel.Category("Metodos"), _
    System.ComponentModel.Description( _
           " Muestra un formulario con los resultados obtenidos")> _
    Public Sub ZShowDialogResultados()
        Call AccionDeMenu_MostrarResultados()
    End Sub

    ''' <summary>
    '''  Muestra la ayuda del control
    ''' </summary>
    <System.ComponentModel.Category("Metodos"), _
    System.ComponentModel.Description( _
           " Muestra la ayuda del control")> _
    Public Shared Sub ZShowDialogAyuda()
        Call AccionDeMenu_Ayuda()
    End Sub

    ''' <summary>
    '''  Inicializa los valores del control
    ''' </summary>
    <System.ComponentModel.Category("Metodos"), _
    System.ComponentModel.Description( _
           "Inicializa los valores del control")> _
    Public Sub ZClear()
        Call AccionDeMenu_Inicializar()
    End Sub

#End Region

#Region "Evento del control"

    ''' <summary>
    '''    Evento que se dispara cada vez que se realiza un calculo de color
    ''' </summary>
    Public Event ZColorCapturado(ByVal sender As Object, ByVal e As EventArgs)

    ''' <summary>
    '''  Disparar el evento ColorCapturado
    ''' </summary>
    Public Sub DispararEventoColorCapturado()
        RaiseEvent ZColorCapturado(Me, New System.EventArgs)
    End Sub



#End Region

#Region "Control del raton"


    '-----------------------------------------------------------------------
    Private Sub ButtonArrastraRaton_MouseDown( _
            ByVal sender As Object, _
            ByVal e As System.Windows.Forms.MouseEventArgs) _
            Handles ButtonArrastraRaton.MouseDown

        ' borrar la imagen
        ButtonArrastraRaton.Image = Nothing
        ' poner el cursor con una cruz
        Cursor.Current = Cursors.Cross
        ' inicio del proceso de buscar color (Instanciar variables)
        Call InicioBuscarColor()
    End Sub

    '-----------------------------------------------------------------------
    Private Sub ButtonArrastraRaton_MouseMove( _
            ByVal sender As Object, _
            ByVal e As System.Windows.Forms.MouseEventArgs) _
            Handles ButtonArrastraRaton.MouseMove

        ' solo funciona si esta pulsado el boton derecho del raton
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ' poner el color 
            Me.ButtonArrastraRaton.BackColor = GetColorPixel()
        End If
    End Sub

    '-----------------------------------------------------------------------
    Private Sub ButtonArrastraRaton_MouseUp( _
            ByVal sender As Object, _
            ByVal e As System.Windows.Forms.MouseEventArgs) _
            Handles ButtonArrastraRaton.MouseUp

        ' restaurar la imagen del boton
        ButtonArrastraRaton.Image = My.Resources.ColorHS
        ' restaurar el cursor por defecto
        Cursor.Current = Cursors.Default
        '--------------------------------------------
        ' Almacenar el color obtenido
        Me.ButtonArrastraRaton.BackColor = GetColorPixel()
        ' finalizar el proceso de buscar color
        Call FinBuscarColor()
    End Sub





#End Region

#Region "Proceso de obtrencion del color"

    '-----------------------------------------------------------------------
    'Variables de la clase
    '-----------------------------------------------------------------------
    'Imagen para averiguar el color del Pixel, no se muestra
    'Creamos una imagen con tamaño 1*1 para averiguarl el color
    <NonSerializedAttribute()> _
    Private _btmp As Bitmap

    'Creamos el objeto [Graphics] a partir de la imagen
    <NonSerializedAttribute()> _
    Private _grfx As Graphics

    ' posicion del cursor
    <NonSerializedAttribute()> _
     Private _posicionCursor As Point

    ' Color Obtenido
    Private _colorCalculado As System.Drawing.Color = Color.White

    '-----------------------------------------------------------------------
    ' Inicializar los valores de las variables que intervienen en la captura del color
    Private Sub InicioBuscarColor()
        'Imagen para averiguar el color del Pixel, no se muestra
        'Creamos una imagen con tamaño 1*1 para averiguarl el color
        _btmp = New Bitmap(1, 1)

        'Creamos el objeto [Graphics] a partir de la imagen
        _grfx = Graphics.FromImage(_btmp)

    End Sub

    '-----------------------------------------------------------------------
    ' Finalizar las variables que intervienen en la captura del color
    Private Sub FinBuscarColor()
        ' La libreria MSDN indica que se debe llamar explictamente al 
        ' metodo [Dispose] de [Graphics] cuando no se necesite mas
        If Not _btmp Is Nothing Then
            ' Comprobar si se puede llamar al dipose del objeto
            If TypeOf _btmp Is IDisposable Then
                _btmp.Dispose()
            End If
            ' objeto a null
            _btmp = Nothing
        End If

        If Not _grfx Is Nothing Then
            ' Comprobar si se puede llamar al dipose del objeto
            If TypeOf _grfx Is IDisposable Then
                _grfx.Dispose()
            End If
            ' objeto a null
            _grfx = Nothing
        End If
    End Sub

    '-----------------------------------------------------------------------
    ' Proceso de obtencion del color del pixel sobre el que esta el cursor
    Private Function GetColorPixel() As Drawing.Color
        'Obtenemos la posición del cursor  y almacenarlo en la variable de clase
        _posicionCursor = Cursor.Position

        ' copiar el rectangulo donde esta el cursor en el bitmap
        ' en el bitmap de un pixel que hemos creado
        _grfx.CopyFromScreen(_posicionCursor, New Point(0, 0), _btmp.Size)

        ' Obtener el color del pixel y almacenarlo en la variable de clase
        _colorCalculado = _btmp.GetPixel(0, 0)

        '  Disparar el evento ColorCapturado
        Call DispararEventoColorCapturado()

        ' Devolver valor del color
        Return _colorCalculado
    End Function

#End Region

#Region "Menu contextual"

    '--------------------------------------------------------------------
    ' Inicializar
    Private Sub AccionDeMenu_Inicializar()
        ' restaurar la imagen del boton
        ButtonArrastraRaton.Image = My.Resources.ColorHS

        ' poner el color del fondo del control
        Me.ButtonArrastraRaton.BackColor = Me.BackColor
        Me._colorCalculado = Me.BackColor

        ' poner un valor 0,0 en el cursor
        Me._posicionCursor = New Point(0, 0)

        ' restaurar el cursor por defecto
        Cursor.Current = Cursors.Default

        ' finalizar el proceso de buscar color
        Call FinBuscarColor()

        '  Disparar el evento ColorCapturado
        Call DispararEventoColorCapturado()
    End Sub

    '--------------------------------------------------------------------
    ' Ayuda
    Private Shared Sub AccionDeMenu_Ayuda()
        Dim formAyuda As New UCBuscaColorAyudaForm
        formAyuda.ShowDialog()
        formAyuda.Close()
        formAyuda.Dispose()
        formAyuda = Nothing
    End Sub

    '--------------------------------------------------------------------
    ' AcercaDe
    Private Shared Sub AccionDeMenu_AcercaDE2008()
        Dim formAyuda As New UCBuscaColorAcercaDE2008
        formAyuda.ShowDialog()
        formAyuda.Close()
        formAyuda.Dispose()
        formAyuda = Nothing
    End Sub


    '--------------------------------------------------------------------
    ' Resultados
    Private Sub AccionDeMenu_MostrarResultados()
        Dim formResultado As New UCBuscaColorResultadoForm
        formResultado.ZSetDatos(Me._colorCalculado, Me._posicionCursor)
        formResultado.ShowDialog()
        formResultado.Close()
        formResultado.Dispose()
        formResultado = Nothing
    End Sub


    Private Sub InicializarToolStripMenuItem_Click( _
           ByVal sender As System.Object, ByVal e As System.EventArgs) _
           Handles InicializarToolStripMenuItem.Click
        Call AccionDeMenu_Inicializar()
    End Sub

    Private Sub AyudaToolStripMenuItem_Click( _
           ByVal sender As System.Object, ByVal e As System.EventArgs) _
           Handles AyudaToolStripMenuItem.Click
        Call AccionDeMenu_Ayuda()
    End Sub

    Private Sub AcercaDeToolStripMenuItem_Click( _
           ByVal sender As System.Object, ByVal e As System.EventArgs) _
           Handles AcercaDeToolStripMenuItem.Click
        Call AccionDeMenu_AcercaDE2008()
    End Sub

    Private Sub VerResultadosToolStripMenuItem_Click( _
          ByVal sender As System.Object, ByVal e As System.EventArgs) _
          Handles VerResultadosToolStripMenuItem.Click
        Call AccionDeMenu_MostrarResultados()
    End Sub
#End Region



End Class
