﻿

'
'
'/**
'--------------------------------------------------
' Version .....: 05/11/2008 10:35:53   
'               [dd/mm/aaaa] 
' Original en .: DllColor
'--------------------------------------------------
'
'
' -------------------------------------------------
' Clase ....: borrar
' Lenguaje .: (.NET Framework 3.5) - Visual Basic .NET (Version 9.0) - 2008
' Autor ....: Mi Casita - AGUILA - Joaquin
' Emilio ...: mailto:joaquin@medina.name
'
' DESCRIPCION.:
'      Formulario que muestra los RESULTADOS para el control [UCBuscaColor]
'
' OBSERVACIONES.:
'     Sin la referecia [Microsoft.VisualBasic] Sin Usar ControlChars
'
' BIBLIOGRAFIA.:
'    ### falta la Bibliografía ###
'
' MODIFICACIONES [dd/mm/aaaa] 
' - 05/11/2008 10:35:53 - Creación 
' -------------------------------------------------
'
'*/
'


''' <summary>
'''   Formulario que muestra los RESULTADOS para el control [UCBuscaColor]
''' </summary>
Friend NotInheritable Class UCBuscaColorResultadoForm

    Private Sub ButtonCerrar_Click( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles ButtonCerrar.Click

        Me.Close()
    End Sub


    ''' <summary>
    '''     Entra el color para mostrar los resultados
    ''' </summary>
    Public Sub ZSetDatos( _
           ByVal colorObtenido As System.Drawing.Color, _
           ByVal coordenadas As Drawing.Point)

        Using sw As New System.IO.StringWriter( _
                 System.Globalization.CultureInfo.CurrentCulture)
            '-----------------------------------------
            ' Montar el mensaje
            '-----------------------------------------
            sw.WriteLine("")
            sw.WriteLine(" BUSCADOR DE COLOR - RESULTADOS -")
            sw.WriteLine("---------------------------------------")
            sw.WriteLine("Fecha y hora: " & _
                         Date.Now.ToShortDateString & " " & Date.Now.ToLongTimeString)

            sw.WriteLine("")
            sw.WriteLine("Alto  de la pantalla.......X=: " & _
                         Windows.Forms.Screen.PrimaryScreen.WorkingArea.Width)
            sw.WriteLine("Ancho de la pantalla.......Y=: " & _
                         Windows.Forms.Screen.PrimaryScreen.WorkingArea.Height)
            sw.WriteLine("Posición del cursor..........: " & coordenadas.ToString)

            sw.WriteLine("")

            '--------------------------------------------------------------
            Dim provider As System.Globalization.CultureInfo
            provider = System.Globalization.CultureInfo.CurrentCulture
            Dim cadenaFormato As String = String.Empty
            Dim auxResultado As String = String.Empty
            '--------------------------------------------------------------


            sw.WriteLine("")
            sw.WriteLine("")
            sw.WriteLine("----------------------------------------------------")
            sw.WriteLine("Leyenda ARGB")
            sw.WriteLine("(A)lfa        , (R)ed , (G)reen , (B)lue")
            sw.WriteLine(" Transparencia,  Rojo ,  Verde  ,  Azul")
            sw.WriteLine("----------------------------------------------------")
            sw.WriteLine("")

            '--------------------------------------------------------------

            cadenaFormato = _
            "[ARGB Hex] [A={0:X2},  R={1:X2},  G={2:X2},  B={3:X2}]"

            auxResultado = String.Format( _
                             provider, _
                             cadenaFormato, _
                               colorObtenido.A, colorObtenido.R, _
                               colorObtenido.G, colorObtenido.B)

            sw.WriteLine(auxResultado)
            sw.WriteLine("")
            '--------------------------------------------------------------

            cadenaFormato = _
               "[ARGB Dec] [A={0:g3}, R={1:g3}, G={2:g3}, B={3:g3}]"

            auxResultado = String.Format( _
                             provider, _
                             cadenaFormato, _
                               colorObtenido.A, colorObtenido.R, _
                               colorObtenido.G, colorObtenido.B)

            sw.WriteLine(auxResultado)
            sw.WriteLine("")

            '--------------------------------------------------------------

            cadenaFormato = _
               "[ARGB  % ] [A={0:g3}%, R={1:g3}%, G={2:g3}%, B={3:g3}%]"

            auxResultado = String.Format( _
                             provider, _
                             cadenaFormato, _
                                Convert.ToInt32((colorObtenido.A * 100) / 255), _
                                Convert.ToInt32((colorObtenido.R * 100) / 255), _
                                Convert.ToInt32((colorObtenido.G * 100) / 255), _
                                Convert.ToInt32((colorObtenido.B * 100) / 255))

            sw.WriteLine(auxResultado)
            sw.WriteLine("")


            '--------------------------------------------------------------

            cadenaFormato = "Color en formato HTML ...: #{0:X2}{1:X2}{2:X2}"
            auxResultado = String.Format( _
                             provider, _
                             cadenaFormato, _
                             colorObtenido.R, colorObtenido.G, colorObtenido.B)

            sw.WriteLine(auxResultado)
            sw.WriteLine("")


            '--------------------------------------------------------------
            sw.WriteLine("Nombre del color(si existe)..: " & _
                         ObtenerNombreDelColor(colorObtenido))

            '--------------------------------------------------------------
            sw.WriteLine("")
            sw.WriteLine("--- Fin del informe ---")
            sw.WriteLine("")



            sw.Flush()

            Me.TextBoxAyuda.Text = sw.ToString
        End Using

    End Sub


    '----------------------------------------------------------------
    ' Devuelve el nombre de un color (si existe), P.E.: 'violet',
    ' si no existe devuelve la cadena 'El color no tiene nombre'
    '----------------------------------------------------------------
    ''' <summary>
    ''' Devuelve el nombre de un color (si existe), P.E.: 'violet',
    ''' </summary>
    ''' <param name="valueColor">El color que se va a analizar</param>
    ''' <returns> 
    ''' Devuelve el nombre de un color (si existe), P.E.: 'violet',
    ''' si no existe devuelve la cadena 'El color no tiene nombre'
    '''</returns>
    Private Shared Function ObtenerNombreDelColor( _
                      ByVal valueColor As System.Drawing.Color) As String


        '---------------------------------------------------
        ' ejemplo de como se carga un combo con los colores
        ' cargar el combo con los nombres de los colores
        'Dim NombreColor As String
        'For Each NombreColor In [Enum].GetNames(GetType(KnownColor))
        '    CboColores.Items.Add(NombreColor)
        'Next
        '---------------------------------------------------

        ' montar la salida por defecto
        Dim Salida As String = "El color no tiene nombre"

        ' recorrer toda la enumeracion para buscar el  ombre del color
        Dim NombreEnumeracion As System.Drawing.KnownColor
        Dim ColorEnumeracion As System.Drawing.Color

        For Each NombreEnumeracion In [Enum].GetValues( _
                                   GetType(System.Drawing.KnownColor))
            ColorEnumeracion = System.Drawing.Color. _
                                      FromKnownColor(NombreEnumeracion)
            If ColorEnumeracion.ToArgb = valueColor.ToArgb Then
                Salida = NombreEnumeracion.ToString
            End If
        Next

        ' destruir objetos utilizados
        NombreEnumeracion = Nothing
        ColorEnumeracion = Nothing
        '-----------------------------
        Return Salida
    End Function



    Private Sub UCBuscaColorResultadoForm_Load( _
            ByVal sender As System.Object, ByVal e As System.EventArgs) _
            Handles MyBase.Load
        Me.Location = New System.Drawing.Point(0, 0)

    End Sub
End Class